/****************************************************************************
**
** Copyright (C) 2016 The Qt Company Ltd.
** Contact: https://www.qt.io/licensing/
**
** This file is part of the Qt Charts module of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:GPL$
** Commercial License Usage
** Licensees holding valid commercial Qt licenses may use this file in
** accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and The Qt Company. For licensing terms
** and conditions see https://www.qt.io/terms-conditions. For further
** information use the contact form at https://www.qt.io/contact-us.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License version 3 or (at your option) any later version
** approved by the KDE Free Qt Foundation. The licenses are as published by
** the Free Software Foundation and appearing in the file LICENSE.GPL3
** included in the packaging of this file. Please review the following
** information to ensure the GNU General Public License requirements will
** be met: https://www.gnu.org/licenses/gpl-3.0.html.
**
** $QT_END_LICENSE$
**
****************************************************************************/
/*
 * Copyright (c) 2019, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
*/

import QtQuick 2.0
import QtCharts 2.1

ChartView {
    id: chartViewPdm
    animationOptions: ChartView.NoAnimation
    theme: ChartView.ChartThemeBlueCerulean
    property bool openGL: true 
    property bool openGLSupported: true

    legend.font.pointSize: 16

    ValueAxis {
        id: axisY1
        min: 0 
        max: 0.003
    }

    ValueAxis {
        id: axisX
        min: 0
        max: 256 
    }

    /* Line series for prediction error */
    LineSeries {
        id: lineSeries1Pdm
        name: "Prediction Error"
        width: 3
        color: "sandybrown"
        axisX: axisX
        axisY: axisY1
        useOpenGL: chartViewPdm.openGL
    }

    /* Line series to draw the threshold line */
    LineSeries {
        id: lineSeries2Pdm
        name: "Threshold"
        width: 3
        color: "#1e90ff"
        axisX: axisX
        axisY: axisY1
        useOpenGL: chartViewPdm.openGL
    }

    /* Line series to draw the anomaly line */
    LineSeries {
        id: lineSeries3Pdm
        name: "Anomaly"
        width: 3
        color: "#ff0000"
        axisX: axisX
        axisY: axisY1
        useOpenGL: chartViewPdm.openGL
    }

    /* Timer to update the detection result display */
    Timer {
        id: refreshTimer
        interval: 1 / 30 * 1000 // 30 Hz
        running: true
        repeat: true
        onTriggered: {
            dataSource.update(3, chartViewPdm.series(0));
            dataSource.update(4, chartViewPdm.series(1));
            dataSource.update(5, chartViewPdm.series(2));
        }
    }

    function createAxis(min, max) {
        // The following creates a ValueAxis object that can be then set as a x or y axis for a series
        return Qt.createQmlObject("import QtQuick 2.0; import QtCharts 2.0; ValueAxis { min: "
                                  + min + "; max: " + max + " }", chartViewPdm);
    }

    function changeRefreshRate(rate) {
        refreshTimer.interval = 1 / Number(rate) * 1000;
    }
}
